Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1115881 - Review Request: scheme48 - Scheme48 Scheme implementation
Summary: Review Request: scheme48 - Scheme48 Scheme implementation
Keywords:
Status: CLOSED NOTABUG
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard: NotReady, StalledSubmitter
Depends On:
Blocks: FE-DEADREVIEW
TreeView+ depends on / blocked
 
Reported: 2014-07-03 09:30 UTC by Christopher Meng
Modified: 2016-03-09 22:46 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-03-09 22:46:18 UTC


Attachments (Terms of Use)

Description Christopher Meng 2014-07-03 09:30:02 UTC
Spec URL: http://us-la.cicku.me/scheme48.spec
SRPM URL: http://us-la.cicku.me/scheme48-1.9.2-1.fc21.src.rpm
Description: Scheme 48 is an implementation of the Scheme programming language as described in the Revised 5 Report on the Algorithmic Language Scheme. It is
based on a compiler and interpreter for a virtual Scheme machine. Scheme 48
tries to be faithful to the Revised 5 Scheme Report, providing neither more 
nor less in the initial user environment.

The name ‘Scheme 48’ commemorates our having written the original version
in forty-eight hours, on August 6th and 7th, 1986.
Fedora Account System Username: cicku
Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=7102659

Comment 1 Jerry James 2014-07-03 19:17:41 UTC
I will ignore the warnings about -devel files being in a non-devel package,
since this really is a -devel package.

Issues:
1. I see warnings in the build log about breaking strict aliasing rules when
   compiling c/r6rs/ieee_bytevect.c.  This means that, to be safe, that file
   must be patched or compiled with -fno-strict-aliasing.  Otherwise, the
   optimizer may emit code that does not behave as expected.  (I have actually
   patched code that looks very much like this in other packages, and had the
   patches accepted upstream.  Let me know if you'd like me to produce a patch
   for this issue.)
2. Consider splitting the documentation out into a -doc subpackage.
3. Multiple files are installed into %{_includedir}, including some that are
   not .h files.  Consider moving those to a subdirectory, say
   /usr/include/scheme48.  (This would also require patching the scheme48
   compiler, of course.)
4. The license is identified as GPLv3+, but I do not think that is correct.
   Here is a breakdown of the various licenses in play, corresponding to the
   list in COPYING:
   - The main license is BSD (New BSD).
   - The bignum code is BSD (New BSD).
   - The code in c/free.c is MIT (Modern Style with sublicense).
   - The autoconf files, mkinstalldirs, INSTALL, and install-sh are not part
     of the binary distribution.  We can ignore them for license purposes.
   - c/srfi-27.c carries no license information that I can find.  This could
     be a problem, unless license information is available elsewhere.
   - Files in scheme/srfi:
     o Identified as part of scheme48, so BSD: packages.scm, srfi-2.scm,
       srfi-4.scm, srfi-5.scm, srfi-7.scm, srfi-13-check.scm,
       srfi-14-char-sets.scm, srfi-14-check.scm, srfi-17.scm,
       srfi-19-check.scm, srfi-39.scm, srfi-66.scm, srfi-74.scm, srfi-95.scm,
       srfi-95-check.scm, test-packages.scm
     o MIT (all Modern Style with sublicense): srfi-11.scm, srfi-14.scm,
       srfi-16.scm, srfi-19.scm, srfi-25.scm, srfi-27.scm, srfi-28.scm,
       srfi-40.scm, srfi-42.scm, srfi-45.scm, srfi-61.scm, srfi-63.scm,
       srfi-67.scm, srfi-71.scm, srfi-78.scm
     o Public Domain: srfi-26.scm, srfi-43.scm
     o srfi-1.scm: I don't know what to call this, maybe check with
       fedora-legal on the name to give it.
     o srfi-13.scm: MIT and BSD
     o srfi-14-base-char-sets.scm: generated file
     o srfi-37.scm: BSD
     o srfi-60.scm: MIT and MIT with advertising
   - scheme/sort code
     o Most are similar to srfi-1.scm; check with fedora-legal on the name.
     o Public Domain: sortp.scm, vbinsearch.scm
     o test-packages.scm: part of scheme48, so BSD
     o vhsort.scm, vqsort2.scm: "open source", may need fedora-legal input on
       these ones, too
   - Basis Technology Corp. code, covered by main scheme48 license (BSD)
   - tex2page files: I don't see them in the distribution.

   Whew!  So I think the license needs to be "BSD and MIT and MIT with
   advertising and Public Domain and <whatever the unknown licenses are
   called>", and a license for c/srfi-27.c needs to be identified.
5. The directory %{_libdir}/scheme48-%{version} is owned by this package, but
   the directory %{_libdir}/scheme48 is not.  Are both really needed?  Can
   they be consolidated?
6. See the first item in the SHOULD section.  Maybe that Requires should be
   filtered?
7. Can a %check section be added?  I see a check target in Makefile.in.
8. Can the noarch parts of the package be split out into a noarch subpackage?
   See the note under "EXTRA items" below.
9. There are various warnings by rpmlint that should be addressed, namely:
   o The package name is repeated in the summary.
   o The word "described" is hyphenated in the description.  It's probably
     better not to do that, and let consuming packages figure out how to
     hyphenate words if the available horizontal space is insufficient.
   o Check the missing-call-to-setgroups warning on posix.so.  Is that a
     legitimate warning?
   o Some files are not UTF-8.
   o Check the wrong-script-interpreter and non-executable-script warnings.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Large documentation must go in a -doc subpackage. Large could be size (~1MB)
  or number of files.
  Note: Documentation size is 2519040 bytes in 27 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (3 clause)", "Unknown or generated". 128 files have unknown license.
[x]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/scheme48/bin,
     /usr/lib64/scheme48
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
     Note: Incorrect Requires : /usr/lib64/scheme48/bin/scheme-srfi-7
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#FileDeps
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 5027840 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: scheme48-1.9.2-1.fc21.x86_64.rpm
          scheme48-1.9.2-1.fc21.src.rpm
scheme48.x86_64: W: name-repeated-in-summary C Scheme48
scheme48.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
scheme48.x86_64: W: spelling-error %description -l en_US scribed -> scribes, scribe, ascribed
scheme48.x86_64: E: missing-call-to-setgroups /usr/lib64/scheme48-1.9.2/posix.so
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/lib64/scheme48/bin/scheme48-config
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/deriving.txt
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48.h
scheme48.x86_64: E: wrong-script-interpreter /usr/include/scheme48.exp ..
scheme48.x86_64: E: non-executable-script /usr/include/scheme48.exp 0644L ..
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48arch.h
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/README
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/COPYING
scheme48.x86_64: E: wrong-script-interpreter /usr/include/scheme48-external.exp ..
scheme48.x86_64: E: non-executable-script /usr/include/scheme48-external.exp 0644L ..
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48write-barrier.h
scheme48.x86_64: W: no-manual-page-for-binary scheme48-config
scheme48.src: W: name-repeated-in-summary C Scheme48
scheme48.src: W: spelling-error %description -l en_US de -> DE, ed, d
scheme48.src: W: spelling-error %description -l en_US scribed -> scribes, scribe, ascribed
2 packages and 0 specfiles checked; 5 errors, 14 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint scheme48
scheme48.x86_64: W: name-repeated-in-summary C Scheme48
scheme48.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
scheme48.x86_64: W: spelling-error %description -l en_US scribed -> scribes, scribe, ascribed
scheme48.x86_64: E: missing-call-to-setgroups /usr/lib64/scheme48-1.9.2/posix.so
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/lib64/scheme48/bin/scheme48-config
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/deriving.txt
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48.h
scheme48.x86_64: E: wrong-script-interpreter /usr/include/scheme48.exp ..
scheme48.x86_64: E: non-executable-script /usr/include/scheme48.exp 0644L ..
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48arch.h
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/README
scheme48.x86_64: W: file-not-utf8 /usr/share/doc/scheme48/COPYING
scheme48.x86_64: E: wrong-script-interpreter /usr/include/scheme48-external.exp ..
scheme48.x86_64: E: non-executable-script /usr/include/scheme48-external.exp 0644L ..
scheme48.x86_64: W: devel-file-in-non-devel-package /usr/include/scheme48write-barrier.h
scheme48.x86_64: W: no-manual-page-for-binary scheme48-config
1 packages and 0 specfiles checked; 5 errors, 11 warnings.
# echo 'rpmlint-done:'



Requires
--------
scheme48 (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/lib64/scheme48/bin/scheme-srfi-7
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libm.so.6()(64bit)
    libnsl.so.1()(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)



Provides
--------
scheme48:
    scheme48
    scheme48(x86-64)



Unversioned so-files
--------------------
scheme48: /usr/lib64/scheme48-1.9.2/ffi-test.so
scheme48: /usr/lib64/scheme48-1.9.2/posix.so
scheme48: /usr/lib64/scheme48-1.9.2/r6rs.so
scheme48: /usr/lib64/scheme48-1.9.2/srfi-27.so

Source checksums
----------------
http://s48.org/1.9.2/scheme48-1.9.2.tgz :
  CHECKSUM(SHA256) this package     : 9c4921a90e95daee067cd2e9cc0ffe09e118f4da01c0c0198e577c4f47759df4
  CHECKSUM(SHA256) upstream package : 9c4921a90e95daee067cd2e9cc0ffe09e118f4da01c0c0198e577c4f47759df4


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1115881 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 Jerry James 2016-02-18 03:34:21 UTC
Christopher, do you have any intention of continuing with this review?


Note You need to log in before you can comment on or make changes to this bug.